-- Upgrade script to 5.2 from 5.3.

-- fix store procedures related to MSD
CREATE OR REPLACE PROCEDURE INSERT_METADATA_TARGET(
 p_id IN  varchar2,
 p_MSD_ID IN number,
 p_pk OUT  number)
IS
BEGIN
  insert into ITEM (ITEM_ID, ID) VALUES (ITEM_SEQ.nextval, p_id);
		select ITEM_SEQ.currval into p_pk from dual;
		insert into METADATA_TARGET (MDT_ID,MSD_ID) VALUES (p_pk,p_MSD_ID);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_REPORT_STRUCTURE(
 p_id IN  varchar2,
 p_MSD_ID IN number,
 p_pk OUT  number)
IS
BEGIN
  insert into ITEM (ITEM_ID, ID) VALUES (ITEM_SEQ.nextval, p_id);
		select ITEM_SEQ.currval into p_pk from dual;
		insert into REPORT_STRUCTURE (RS_ID,MSD_ID) VALUES (p_pk,p_MSD_ID);
END;
/

-- add on delete cascade in MSD related tables

-- create a temporary proc for removing foreign keys if they exist
create or replace procedure PROC_DROP_FOREIGN_KEY(p_table varchar2, p_constraint varchar2) is
   e exception;
   pragma exception_init (e, -2443);
begin
   execute immediate 'alter table ' || p_table || ' drop constraint '||p_constraint;
exception
   when e then null;
end;
/

begin
  PROC_DROP_FOREIGN_KEY('METADATA_TARGET', 'FK_METADATA_TARGET_TO_ITEM');
end;
/
ALTER TABLE METADATA_TARGET   ADD  CONSTRAINT FK_METADATA_TARGET_TO_ITEM FOREIGN KEY(MDT_ID)
REFERENCES ITEM (ITEM_ID)
ON DELETE CASCADE
;



-- rename to match name in MySQL and SQL Server. The limit in Oracle is 30 characters
begin
    PROC_DROP_FOREIGN_KEY('TARGET_OBJECT', 'FK_TAR_OBJ_To_CCOMMON');
end;
/

begin
    PROC_DROP_FOREIGN_KEY('TARGET_OBJECT', 'FK_TARGET_OBJECT_To_CCOMMON');
end;
/


ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TARGET_OBJECT_To_CCOMMON FOREIGN KEY(TARGET_OBJ_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

begin
    PROC_DROP_FOREIGN_KEY('TARGET_OBJECT', 'FK_TARGET_OBJECT_To_MDT');
end;
/


ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TARGET_OBJECT_To_MDT FOREIGN KEY(MDT_ID)
REFERENCES METADATA_TARGET (MDT_ID)
ON DELETE CASCADE
;

begin
    PROC_DROP_FOREIGN_KEY('METADATA_TARGET', 'FK_METADATA_TARGET_TO_MSD');
end;
/


ALTER TABLE METADATA_TARGET   ADD  CONSTRAINT FK_METADATA_TARGET_TO_MSD FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
ON DELETE CASCADE
;

begin
    PROC_DROP_FOREIGN_KEY('METADATA_STRUCTURE_DEFINITION', 'FK_MSD_TO_ARTEFACT');
end;
/


ALTER TABLE METADATA_STRUCTURE_DEFINITION   ADD  CONSTRAINT FK_MSD_TO_ARTEFACT FOREIGN KEY(MSD_ID)
REFERENCES ARTEFACT (ART_ID)
ON DELETE CASCADE
;

begin
    PROC_DROP_FOREIGN_KEY('REPORT_STRUCTURE', 'FK_REPORT_STRUCTURE_To_ITEM');
end;
/



ALTER TABLE REPORT_STRUCTURE   ADD  CONSTRAINT FK_REPORT_STRUCTURE_To_ITEM FOREIGN KEY(RS_ID)
REFERENCES ITEM (ITEM_ID)
ON DELETE CASCADE
;

begin
    PROC_DROP_FOREIGN_KEY('REPORT_STRUCTURE', 'FK_REPORT_STRUCTURE_To_MSD');
end;
/


ALTER TABLE REPORT_STRUCTURE   ADD  CONSTRAINT FK_REPORT_STRUCTURE_To_MSD FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
ON DELETE CASCADE
;

-- add on delete cascade
begin
    PROC_DROP_FOREIGN_KEY('REPORT_STRUCTURE_META_TARGET', 'FK_REP_STRUCT_META_TAR_MD_TAR');
end;
/


ALTER TABLE REPORT_STRUCTURE_META_TARGET   ADD  CONSTRAINT FK_REP_STRUCT_META_TAR_MD_TAR FOREIGN KEY(MDT_ID)
REFERENCES METADATA_TARGET (MDT_ID)
ON DELETE CASCADE
;


begin
    PROC_DROP_FOREIGN_KEY('METADATA_ATTRIBUTE', 'FK_MD_ATTR_COMP_COMMON');
end;
/

ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_COMP_COMMON FOREIGN KEY(MTD_ATTR_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

begin
    PROC_DROP_FOREIGN_KEY('METADATA_ATTRIBUTE', 'FK_MD_ATTR_MD_ATTR');
end;
/

ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_MD_ATTR FOREIGN KEY(PARENT)
REFERENCES METADATA_ATTRIBUTE (MTD_ATTR_ID)
;

DROP PROCEDURE PROC_DROP_FOREIGN_KEY
;
-- add field for notifications
alter table DATAFLOW add ( DATA_LAST_UPDATE timestamp null)
;

-- always last
update DB_VERSION SET VERSION = '5.3'
;

